%define major 2
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d
%define staticname %mklibname %{name} -d -s
%define revnum rev2531

Summary:	Professional 3D collision detection library
Summary(de):	Professionelle 3D Collision Detection Bibliothek
Name:		bullet
Version:	2.80
Release:	%mkrel 1
License:	open source ZLib, proprietary with additional info in respective distributed LICENSE files
Group:		System/Libraries
Url:		http://www.continuousphysics.com/Bullet/index.html
Source0:	http://bullet.googlecode.com/files/bullet-%{version}-%{revnum}.tar.xz
Patch1:		%{name}-2.67-shared-libraries.patch
Patch2:		%{name}-2.67-x86_64-fixes.patch
Patch3:		%{name}-2.67-use-system-libxml2.patch
BuildRequires:	doxygen
BuildRequires:	mesa-common-devel
BuildRequires:	ftjam
BuildRequires:	libtool
BuildRequires:	%{_lib}xml2-devel
BuildRequires:  cmake
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Bullet is a professional open source multi-threaded 
3D Collision Detection and Rigid Body Dynamics Library
for games and animation.

%description -l de
Bullet ist eine professionelle Open Source, multi-threaded 
3D Collision Detection und Rigid Body Dynamics Bibliothek für
Spiele und Animationen.

%package demo
Summary:	A demo programs using bullet library
Summary(de):	Demoprogramme, die die Bullet-Bibliothek benutzen.
Group:		Graphics
Requires:	%{libname} = %{version}-%{release}
Requires:	%{name}-extras

%description demo
A demo programs using bullet library.

%description demo -l de
Demoprogramme, die die Bullet-Bibliothek benutzen.

%package -n %{libname}
Summary:	Professional 3D collision detection library
Summary(de):	Professionelle 3D Collision Detection Bibliothek
Group:		System/Libraries

%description -n %{libname}
Bullet is a professional open source multi-threaded 
3D Collision Detection and Rigid Body Dynamics Library
for games and animation.

%description -n %{libname} -l de
Bullet ist eine professionelle Open Source, multi-threaded 
3D Collision Detection und Rigid Body Dynamics Bibliothek für
Spiele und Animationen.

%package -n %{develname}
Summary:	Development headers for bullet
Summary(de):	Header-Dateien für bullet
Group:		Development/C
Provides:	%{name}-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}

%description -n %{develname}
Development headers for bullet 3D collision library.

%description -n %{develname}
Entwicklungsdateien für die Bullet 3D Kollisionsbibliothek.

# to get static libraries it is necessary to run the complete cmake/make part again
# so the requirement of the devel package isn't needed
%package -n %{staticname}
Summary:	Static libraries for %{name}
Summary(de):	Statische Bibliotheken für %{name}
Group:		Development/C
#Requires:	%{develname} = %{version}-%{release}
Provides:	lib%{name}-static-devel = %{version}-%{release}
Provides:	%{name}-static-devel = %{version}-%{release}

%description -n %{staticname}
Static libraries for %{name}.

%description -n %{staticname} -l de
Statische Bibliotheken für %{name}.

%package extras
Summary:	Extra libraries for %{name}-demos
Summary(de):	Zusatzbibliotheken für %{name}-demos
Group:		Development/C
Requires:	%{develname} = %{version}-%{release}

%description extras
Extra libraries for running the demos in the %{name}-demos
package.

%description extras -l de
Zusatzbibliotheken zum Ausführen des %{name}-demos Paketes.

%prep
%setup -q -n %{name}-%{version}-%{revnum}
#patch1 -p1
#patch3 -p1

#ifnarch ix86
#patch2 -p1
#endif

#chmod +x configure

#pushd mk/autoconf
#chmod +x *
#popd

# get rid of no newline ... warnings
#echo "" >> src/BulletCollision/BroadphaseCollision/btOverlappingPairCallback.h
#echo "" >> src/BulletCollision/NarrowPhaseCollision/btRaycastCallback.cpp

#(tpg) use system libxml2
#rm -rf Extras/LibXML

%build
#(tpg) export USE_ADDR64 only for x86_64, otherwise build fails, use system libxml2
#ifnarch ix86
#export CFLAGS="%{optflags} -fno-strict-aliasing -DUSE_ADDR64 -I%{_includedir}/libxml2"
#else
#export CFLAGS="%{optflags} -fno-strict-aliasing -I%{_includedir}/libxml2"
#endif
#export CXXFLAGS=$CFLAGS
#export LDFLAGS="-lxml2"

./autogen.sh

%cmake -DBUILD_SHARED_LIBS=ON -DBUILD_DEMOS=ON -DBUILD_EXTRAS=ON -DCMAKE_INSTALL_PREFIX=/usr -DINCLUDE_INSTALL_DIR=%{_includedir}/bullet
#configure2_5x \
#	--with-mesa

# parallel build of demos is broken ...
# ... so build first library
#sed -i -e 's|SubInclude TOP Demos ;|#SubInclude TOP Demos ;|g' Jamfile
#jam -d2 %{_smp_mflags}

# ... and then demos
#sed -i -e 's|#SubInclude TOP Demos ;|SubInclude TOP Demos ;|g' Jamfile
#jam -d2

#(tpg) build shared libraries
#pushd lib
#sed -i -e 's/sover/%{version}/g' Makefile
%make
#popd

%install
rm -rf  %{buildroot}
#jam -d2 install DESTDIR=%{buildroot}

install -dm 755 %{buildroot}%{_bindir}


pushd build/Demos
demos=$(ls -1 *Demo | sed 's/://g' | sed 's/Makefile//g' | sed 's/cmake.*//g' | sed 's/CMake.*//g' | sed 's/.*.bullet//g' | sed 's/App.*//g')
demos=$(echo "$demos" | sed 's/MiniCL//g' | sed 's/OpenCLClothDemo//g' | sed 's/.*.bsp//g' | sed 's/.*.obj//g')

echo "$demos"

for i in $demos AllBulletDemos Benchmarks ConvexHullDistance HelloWorld Raytracer UserCollisionAlgorithm; do
    	kk=App$i

	if [ $i == "BspDemo" ]; then
		kk=AppBspPhysicsDemo
	fi

	if [ $i == "ConcaveConvexcastDemo" ]; then
		kk=AppConcaveConvexCastDemo
	fi

	if [ $i == "ConcaveRaycastDemo" ]; then
		kk=AppConcaveRayCastDemo
	fi

	if [ $i == "DynamicControlDemo" ]; then
		kk=AppMotorDemo
	fi

	if [ $i == "GjkConvexCastDemo" ]; then
		kk=AppLinearConvexCastDemo
	fi

	if [ $i == "HeightFieldFluidDemo" ]; then
		kk=AppHfFluidDemo
	fi

	if [ $i == "SoftDemo" ]; then
		kk=AppSoftBodyDemo
	fi

	if [ $i == "ConvexHullDistance" ]; then
		kk=AppConvexHullDistanceDemo
	fi

	cp %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/Demos/$i/$kk %{buildroot}%{_bindir}/bullet-$kk
	chmod 755 %{buildroot}%{_bindir}/bullet-$kk

done

install -dm 755 %{buildroot}%{_libdir}
cp %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/Demos/OpenGL/lib* %{buildroot}%{_libdir}

popd

pushd build/Extras
extras=$(ls -1 | sed 's/://g' | sed 's/Makefile//g' | sed 's/cmake.*//g' | sed 's/CMake.*//g' | sed 's/.*File.*//g' | sed 's/.*World.*//g')

for i in $extras; do
	if [ $i == "glui" ]; then
		kk=libGLUI
		cp %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/Extras/$i/$kk* %{buildroot}%{_libdir}
	else
		if [ $i == "Serialize" ]; then
			echo "check"
		else
			cp %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/Extras/$i/lib$i* %{buildroot}%{_libdir}
		fi
	fi
done

cp %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/Extras/Serialize/BulletFileLoader/lib* %{buildroot}%{_libdir}
cp %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/Extras/Serialize/BulletWorldImporter/lib* %{buildroot}%{_libdir}

popd



#(tpg) install shared libraries
#cp -f lib/*.so* %{buildroot}%{_libdir}

%makeinstall_std -C build

# copy the extra licenses
#install -dm 775 %{buildroot}%{_docdir}/bullet-extras
#cp %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/Extras/glui/readme.txt %{buildroot}%{_docdir}/bullet-extras/glui


#(tpg) add symlinks
#pushd %{buildroot}%{_libdir}
#for i in libBulletCollision libBulletDynamics libBulletMultiThreaded libBulletSoftBody; do
#ln -s $i.so.%{major}* $i.so
#done
#popd

# clean the build directory we need a new run for the static libraries
rm -rf %{_topdir}/BUILD/%{name}-%{version}-%{revnum}

cp %{_topdir}/SOURCES/%{name}-%{version}-%{revnum}.tar.xz %{_topdir}/BUILD
xz -d %{_topdir}/BUILD/%{name}-%{version}-%{revnum}.tar.xz
cd %{_topdir}/BUILD
tar -xf %{name}-%{version}-%{revnum}.tar
rm %{_topdir}/BUILD/%{name}-%{version}-%{revnum}.tar

cd %{_topdir}/BUILD/%{name}-%{version}-%{revnum}
./autogen.sh
%cmake -DBUILD_SHARED_LIBS=OFF -DBUILD_DEMOS=OFF -DBUILD_EXTRAS=OFF -DCMAKE_INSTALL_PREFIX=/usr -DINCLUDE_INSTALL_DIR=%{_includedir}/bullet
%make

cd %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/src
static=$(ls -1 Bullet* | sed 's/://g' | sed 's/Makefile//g' | sed 's/cmake.*//g' | sed 's/CMake.*//g' | sed 's/GPU.*//g' | sed 's/lib.*//g' | sed 's/Gpu//g' | sed 's/.*Solvers//g')


for i in $static LinearMath MiniCL; do

	cp %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/src/$i/*.a %{buildroot}%{_libdir}
done

cp %{_topdir}/BUILD/%{name}-%{version}-%{revnum}/build/src/BulletMultiThreaded/GpuSoftBodySolvers/OpenCL/MiniCL/libBulletSoftBodySolvers_OpenCL_Mini.a %{buildroot}%{_libdir}

#makeinstall_std -C build

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files demo
%defattr(-,root,root)
%{_bindir}/%{name}-*


%files -n %{libname}
%defattr(-,root,root)
%exclude %{_libdir}/libBulletWorldImporter.so*
%exclude %{_libdir}/libBulletFileLoader.so*
%exclude %{_libdir}/libHACD.so*
%exclude %{_libdir}/libGLUI.so
%exclude %{_libdir}/libConvexDecomposition.so*
%exclude %{_libdir}/libGIMPACTUtils.so*
%{_libdir}/*.so.%{major}*

%files -n %{staticname}
%defattr(-,root,root)
%{_libdir}/libBulletCollision.a
%{_libdir}/libBulletDynamics.a
%{_libdir}/libBulletMultiThreaded.a
#{_libdir}/libbulletmath.a
%{_libdir}/libBulletSoftBody.a
%{_libdir}/libMiniCL.a
%{_libdir}/libLinearMath.a
%{_libdir}/libBulletSoftBodySolvers_OpenCL_Mini.a	 

%files -n %{develname}
%defattr(-,root,root)
%doc AUTHORS README COPYING BulletLicense.txt bullet_logo.png ChangeLog NEWS VERSION *.pdf
%dir %{_includedir}/%{name}
%exclude %{_libdir}/libBulletWorldImporter.so*
%exclude %{_libdir}/libBulletFileLoader.so*
%exclude %{_libdir}/libHACD.so*
%exclude %{_libdir}/libGLUI.so
%exclude %{_libdir}/libConvexDecomposition.so*
%exclude %{_libdir}/libGIMPACTUtils.so*
%{_libdir}/*.so
%{_includedir}/%{name}/*
%{_libdir}/pkgconfig/%{name}.pc

%files extras
%defattr(-,root,root)
%{_libdir}/libGIMPACTUtils.so.%{version}
%{_libdir}/libGIMPACTUtils.so
%{_libdir}/libConvexDecomposition.so.%{version}
%{_libdir}/libConvexDecomposition.so
%{_libdir}/libGLUI.so
%{_libdir}/libHACD.so.%{version}
%{_libdir}/libHACD.so
%{_libdir}/libBulletFileLoader.so.%{version}
%{_libdir}/libBulletFileLoader.so
%{_libdir}/libBulletWorldImporter.so.%{version}
%{_libdir}/libBulletWorldImporter.so

%changelog
* Tue Apr 17 2012 Neal <nealbrks0 at gmail dot com> 2.80-1pclos2012
- process

* Thu Apr 12 2012 ghostbunny <hmhaase at pclinuxosusers dot de> 2.80-1pclos2012
- added %{_lib} macro
- deleted the mandriva changelog entries
- added xz compression
- commented patches, fixed or not available in source
- renamed spec to pclos-bullet.spec
- reworked build and file section, old parts are commented
- added bullet-extras package
- added excludes in files sections to keep the libraries for the extras package
- added german summaries and descriptions

* Thu Apr 03 2008 P. K. Frederic <pkfric@yahoo.com> 2.67-1pclos2007
- first RPM for PCLinuxOS

